class TMP
{
public:
  static string Func[100];
  static int Count;

  TMP( const string Str )
  {
    TMP::Func[TMP::Count++] = Str;
  }

  ~TMP( void )
  {
    if (this.Count)
      TMP::Func[--TMP::Count] = NULL;
  }
};

static string TMP::Func[100];
static int TMP::Count = 0;

// #define CHECKTMP const TMP Tmp##__LINE__(__FUNCSIG__);
#define CHECKTMP

#property strict

// #define USAGE_ALERT 90 //   .

#include <Graphics\Graphic.mqh>

#define _USAGE _USAGE2(__LINE__)

#define _USAGE2(A) USAGE Usage##A;
#define _USAGE_VALUES(A)   \
  double A[];              \
                           \
  USAGE::GetLastValues(A);

#ifndef USAGE_VALUES_AMOUNT
  #define USAGE_VALUES_AMOUNT 30
#endif // #ifndef USAGE_VALUES_AMOUNT

class USAGE
{
private:
  static const string ObjName;

  static ulong StartTime;
  static int Stack;

  static ulong UsageTime;
  static ulong FullTime;

  static ulong InternalStartTime;

  static double PrevValues[USAGE_VALUES_AMOUNT];
  static int Pos;

  static void AddValue( const double Value )
  {
    CHECKTMP

    USAGE::Pos = (USAGE::Pos + 1) % USAGE_VALUES_AMOUNT;

    USAGE::PrevValues[USAGE::Pos] = Value;

  #ifdef USAGE_ALERT
    if (Value >= USAGE_ALERT)
    {
      ::Alert("Usage (" + ::DoubleToString(Value, 1) + "%) >= " + (string)(USAGE_ALERT) + "%");

      double Values[];

      USAGE::GetLastValues(Values, false);

      USAGE::ArrayPrint(Values);
    }
  #endif // #ifdef USAGE_ALERT

    return;
  }

  static void Check( const ulong &NewTime )
  {
    CHECKTMP

    // https://www.mql5.com/ru/forum/364505#comment_21994133
    static ulong PrevNewTime = 0;
    static ulong PrevStartTime = 0;

    static int Count = 0;
    static int Count2 = 0;

    Count++;
    Count2++;

  #define TOSTRING(A) #A + " = " + (string)(A) + " "
    const bool Res = (NewTime - USAGE::StartTime > USAGE::MinInterval * 1000);

    if (Res)
    {
      ::Alert(TOSTRING(NewTime) + TOSTRING(USAGE::StartTime) + TOSTRING(PrevNewTime) + TOSTRING(PrevStartTime) + TOSTRING(USAGE::MinInterval));
      ::Alert(TOSTRING(Count) + TOSTRING(USAGE::Stack) + TOSTRING(Count2));

      for (int i = 0; i < TMP::Count; i++)
        Print(TOSTRING(Count) + TOSTRING(USAGE::Stack) + TOSTRING(Count2) + TOSTRING(i) + TMP::Func[i] +
              TOSTRING(NewTime) + TOSTRING(PrevNewTime));

      ::DebugBreak();

      //    GetMicrosecondCount.
      USAGE::InternalStartTime = NewTime;
      USAGE::StartTime = NewTime;
      USAGE::UsageTime = 0;
      USAGE::FullTime = 0;
    }
  #undef TOSTRING

    PrevNewTime = NewTime;
    PrevStartTime = USAGE::StartTime;

    const ulong AddTime = USAGE::Stack ? NewTime - USAGE::InternalStartTime : 0;
    const ulong NewFullTime = (!Res) ? NewTime - USAGE::StartTime : 0;

    if (NewFullTime >= USAGE::MinInterval)
    {
      const double Velocity = (double)AddTime / (NewFullTime - USAGE::FullTime);

      USAGE::AddValue((USAGE::UsageTime + Velocity * (USAGE::MinInterval - USAGE::FullTime)) * 100 / USAGE::MinInterval);

      USAGE::FullTime = NewFullTime;

      USAGE::StartTime += USAGE::MinInterval;
      USAGE::FullTime -= USAGE::MinInterval;

      while (USAGE::FullTime >= USAGE::MinInterval)
      {
        USAGE::AddValue(Velocity * 100);

        USAGE::StartTime += USAGE::MinInterval;
        USAGE::FullTime -= USAGE::MinInterval;
      }

      USAGE::UsageTime = (int)(Velocity * USAGE::FullTime);
    }
    else
    {
      USAGE::UsageTime += AddTime;

      USAGE::FullTime = NewFullTime;
    }

    USAGE::InternalStartTime = NewTime;

    Count--;

    return;
  }

  template <typename T>
  static void ArrayReverse( T &Array[] )
  {
    CHECKTMP

  #ifdef __MQL5__
    ::ArrayReverse(Array);
  #else // #ifdef __MQL5__
    T Tmp;

    for (int i = 0, j = ::ArraySize(Array) - 1; i < j; i++, j--)
    {
      Tmp = Array[i];

      Array[i] = Array[j];
      Array[j] = Tmp;
    }
  #endif // #ifdef __MQL5__ #else

    return;
  }

  static bool ObjectFind( const uint RefreshTime = 1000 )
  {
    CHECKTMP

    static uint PrevTime = 0;
    static bool PrevRes = false;

    const uint NewTime = ::GetTickCount();

    if (!PrevRes || (NewTime - PrevTime > RefreshTime))
    {
      PrevRes = (::ObjectFind(0, USAGE::ObjName) >= 0); // https://www.mql5.com/ru/forum/342090/page90#comment_21313797

      PrevTime = NewTime;
    }

    return(PrevRes);
  }

public:
  static ulong MinInterval;

  USAGE( void )
  {
    CHECKTMP

    const ulong NewTime = ::GetMicrosecondCount();

    if (!USAGE::Stack++)
      USAGE::InternalStartTime = NewTime;

    USAGE::Check(NewTime);
  }

  ~USAGE( void )
  {
    CHECKTMP

    const ulong NewTime = ::GetMicrosecondCount();

    USAGE::Check(NewTime);

    USAGE::Stack--;
  }

  template <typename T>
  static void ArrayPrint( const T &Array[] )
  {
    CHECKTMP

  #ifdef __MQL5__
    ::ArrayPrint(Array);
  #else // #ifdef __MQL5__
    const int Size = ::ArraySize(Array);
    string Str = NULL;

    for (int i = 0; i < Size; i++)
      Str += " " + (string)Array[i];

    ::Print(Str);
  #endif // #ifdef __MQL5__ #else

    return;
  }

  static int GetLastValues( double &Values[], const bool CheckFlag = true )
  {
    CHECKTMP

    if (CheckFlag)
    {
      const ulong NewTime = ::GetMicrosecondCount();
      USAGE::Check(NewTime);
    }

    const int Size = ::ArrayResize(Values, USAGE_VALUES_AMOUNT);

    for (int i = 0; i < Size; i++)
      Values[i] = USAGE::PrevValues[(USAGE_VALUES_AMOUNT + USAGE::Pos - i) % USAGE_VALUES_AMOUNT];

    return(Size);
  }

  static string GraphCreate( const int Width = 500, const int Height = 300, const uchar Transparency = 250 )
  {
    CHECKTMP

    static const double Array0[] = {0};
    static const double Array100[] = {100};

    class CGraphic2 : public CGraphic
    {
    public:
      void SetTransparency( const uchar Value = 0xFF )
      {
        CHECKTMP

        this.m_canvas.TransparentLevelSet(Value);

        return;
      }

      bool Clear( void )
      {
        CHECKTMP

        this.m_generator.Reset();
        this.m_arr_curves.Clear();

        return(true);
      }

      bool Create( const long chart, const string &name, const int subwin, const int x, const int y, const int &Width, const int &Height )
      {
        CHECKTMP

        bool Res = true; // (::ObjectFind(chart,name) < 0);

        if ((Width > 0) && (Height > 0))
        {
          this.m_width = Width;
          this.m_height = Height;

          if (!(Res = ::ObjectCreate(chart, name, OBJ_BITMAP_LABEL, subwin, 0, 0) &&
                      ::ObjectSetInteger(chart, name, OBJPROP_XDISTANCE, x) &&
                      ::ObjectSetInteger(chart, name, OBJPROP_YDISTANCE, y) &&
                      this.m_canvas.Attach(chart, name, Width, Height, COLOR_FORMAT_ARGB_NORMALIZE)))
            ::ObjectDelete(chart, name);
        }

        return(Res);
      }
    };

    static CGraphic2 Graphic;
    static bool Res = USAGE::ObjectFind() ? Graphic.Attach(0, USAGE::ObjName)
                                          : (Graphic.Create(0, USAGE::ObjName, 0, 50, 50, Width, Height) && USAGE::GraphShow());

    Res = Graphic.Clear() &&
          (USAGE::ObjectFind() || (Graphic.Create(0, USAGE::ObjName, 0, 50, 50, Width, Height) && USAGE::GraphShow()));

    if (Res)
    {
      _USAGE_VALUES(Values);

      const string CurveName = ::DoubleToString(Values[0], 1) + "%";

      USAGE::ArrayReverse(Values);

      Graphic.CurveAdd(Values, CURVE_HISTOGRAM, CurveName).HistogramWidth(::MathMax(1, (int)(0.9 * (Graphic.Width() - 200) / (::ArraySize(Values) + 1))));

    #ifdef USAGE_ALERT
      double ArrayAlert[];

      ::ArrayFill(ArrayAlert, 0, ::ArrayResize(ArrayAlert, ::ArraySize(Values)), USAGE_ALERT);

      Graphic.CurveAdd(ArrayAlert, CURVE_LINES, (string)(USAGE_ALERT) + "%");
    #endif // #ifdef USAGE_ALERT

      Graphic.CurveAdd(Array0, CURVE_NONE, ::TimeToString(::TimeLocal(), TIME_SECONDS));
      Graphic.CurveAdd(Array100, CURVE_NONE, (string)(USAGE::MinInterval / 1000) + " ms.");

      Graphic.CurvePlotAll();

      if (Transparency != 0xFF)
        Graphic.SetTransparency(Transparency);

      Graphic.Update();
    }

    return (Res ? Graphic.ChartObjectName() : NULL);
  }

  static bool GraphDelete( void )
  {
    CHECKTMP

    bool Res = (::ObjectFind(0, USAGE::ObjName) >= 0);

    if (Res)
    {
      const string ResourceName = ::ObjectGetString(0, USAGE::ObjName, OBJPROP_BMPFILE);

      // https://www.mql5.com/ru/forum/170952/page167#comment_15259977
      Res = ::ResourceFree(::StringSubstr(ResourceName, ::StringFind(ResourceName, "::"))) && ::ObjectDelete(0, USAGE::ObjName);

      ::ChartRedraw();
    }

    return(Res);
  }

  static bool GraphShow( void )
  {
    CHECKTMP

    const bool Res = ::ObjectSetInteger(0, USAGE::ObjName, OBJPROP_TIMEFRAMES, OBJ_ALL_PERIODS);

    ::ObjectSetInteger(0, USAGE::ObjName, OBJPROP_HIDDEN, false);
    ::ObjectSetInteger(0, USAGE::ObjName, OBJPROP_SELECTABLE, true);
    ::ObjectSetInteger(0, USAGE::ObjName, OBJPROP_SELECTED, true);

    ::ChartRedraw();

    return(Res);
  }

  static bool GraphHide( void )
  {
    CHECKTMP

    const bool Res = ::ObjectSetInteger(0, USAGE::ObjName, OBJPROP_TIMEFRAMES, OBJ_NO_PERIODS);

    ::ChartRedraw();

    return(Res);
  }
};

#undef CHECKTMP

static const string USAGE::ObjName = "USAGE_" + ::MQLInfoString(MQL_PROGRAM_NAME) + "_" + (string)::ChartID();

static ulong USAGE::StartTime = ::GetMicrosecondCount();
static ulong USAGE::MinInterval = 1000000;

static int USAGE::Stack = 0;

static ulong USAGE::UsageTime = 0;
static ulong USAGE::FullTime = 0;

static ulong USAGE::InternalStartTime = 0;

static double USAGE::PrevValues[USAGE_VALUES_AMOUNT] = {};
static int USAGE::Pos;